package model;

import java.util.ArrayList;

public class Magician extends Piece{

    private Piece copiedPiece;
    public Magician(Position p, int color) {
        super(p, color);
        copiedPiece = new Bishop(p, color);
    }

    public ArrayList<Position> getAvailableMoves(Board b) {
        return copiedPiece.getAvailableMoves(b);
    }

    public Piece getCopiedPiece() {
        return copiedPiece;
    }
    public void setPosition(Position p) {
        this.p = p;
        copiedPiece.setPosition(p);
    }

    public void setCopiedPiece(Piece copiedPiece) {
        this.copiedPiece = copiedPiece;
    }

    public void steal(Piece enemy) {
        // we can't do switch statement on ".getClass()"
        if (enemy.getClass() == Pawn.class) { setCopiedPiece(new Pawn(p, color)); }
        if (enemy.getClass() == Rook.class) { setCopiedPiece(new Rook(p, color)); }
        if (enemy.getClass() == Knight.class) { setCopiedPiece(new Knight(p, color)); }
        if (enemy.getClass() == Bishop.class) { setCopiedPiece(new Bishop(p, color)); }
        if (enemy.getClass() == Queen.class) { setCopiedPiece(new Queen(p, color)); }
        if (enemy.getClass() == King.class) { setCopiedPiece(new King(p, color)); }
        if (enemy.getClass() == Nwap.class) { setCopiedPiece(new Nwap(p, color)); }
        if (enemy.getClass() == Magician.class) { setCopiedPiece(((Magician) enemy).getCopiedPiece()); } // lol, stealing the stealer
        if (enemy.getClass() == Giant.class) { setCopiedPiece(new Giant(p, color)); }
        if (enemy.getClass() == Kamikaze.class) { setCopiedPiece(new Kamikaze(p, color)); }
    }
    public Piece newInstanceCopy() {
        return new Magician(p, color);
    }
}
