package view;

import javafx.scene.*;
import javafx.scene.layout.AnchorPane;
import javafx.scene.paint.Color;

public class CustomScene {
	private final Scene scene;
	private final SubScene subScene;
	public CustomScene(AnchorPane group2d, Group group3d, PerspectiveCamera camera, SceneAntialiasing antialiasing) {
		scene = new Scene(group2d, 1280, 720, true);
		subScene = new SubScene(group3d, 1280, 720, true, antialiasing); // create scene
		subScene.setFill(Color.rgb(50, 50, 50)); // background default color
		subScene.setCamera(camera); // link camera to scene
		group2d.getChildren().add(subScene);
	}
	public Scene get2d() {
		return scene;
	}
	public SubScene get3d() {
		return subScene;
	}
}
